<?php
class AppModel extends Model {
	public function beforeFind($query) {
		if (!empty($this->virtualFields)) {
			$virtualFields = isset($query['virtualFields']) ?
				$query['virtualFields'] :
				array_keys($this->virtualFields);
			if ($virtualFields !== true) {
				$this->_backVirtualFields = $this->virtualFields;
				$this->virtualFields = !empty($virtualFields) ?
					array_intersect_key($this->virtualFields, array_flip((array) $virtualFields)) :
					array();
			}
		}
		return parent::beforeFind($query);
	}

	public function afterFind($results, $primary = false) {
		if (!empty($this->_backVirtualFields)) {
			$this->virtualFields = $this->_backVirtualFields;
		}
		return parent::afterFind($results, $primary);
	}
}
?>